<?php
namespace Modules\Cotacao\Modules\AnaliseCotacoes\Controllers;

use Zeedhi\Framework\DataSource\DataSet;
use Zeedhi\Framework\Controller;
use Zeedhi\Framework\Report\ReportService;
use Zeedhi\Framework\DTO;

class ProdutoNaoCotado extends \Zeedhi\Framework\Controller\Report {

    protected $entityManager;
    protected $qr2Strategy;
    protected $newCode;
    protected $environment;
    protected $connection;
    protected $dataSourceManager;
    protected $birtStrategy;
    protected $stNomeRel;
    

    public function __construct($reportService, $entityManager, $qr2Strategy, $newCode, $environment, $connection, $dataSourceManager, $birtStrategy) {
        $this->entityManager     = $entityManager;
        $this->qr2Strategy       = $qr2Strategy;
        $this->reportService     = $reportService;
        $this->newCode           = $newCode;
        $this->environment       = $environment;
        $this->connection        = $connection;
        $this->dataSourceManager = $dataSourceManager;
        $this->birtStrategy = $birtStrategy;
    }
   
    public function beforeProcessReport(DTO\Request\Row $request, DTO\Response $response) {
        
        $row = $request->getRow();
        $this->birtStrategy->setReportFormat(strtolower($row['QR2TYPE']));
        $this->qr2Strategy->setQr2Type($row['QR2TYPE']);
        $this->stNomeRel = $this->getReportName($row);
        $row['P_NRORG'] = $this->environment->getNrorgTrab();
        $row['CDFILIAL'] = $this->getCdFilial();
        $row['CDFILLANCA'] = $row['CDFILLANCA'];
        $row['NRSOLICMP'] = $row['NRSOLICMP'];
        $row['CDOPERADOR'] = $row['CDOPERADOR'];
        $row['CDREGIAO'] = $row['CDREGIAO'];
        $row['CDFILSOLI'] = $row['CDFILSOLI'];
        $row['DTINICIAL'] = $row['DT_ENTREGA']['start'];
        $row['DTFINAL'] = $row['DT_ENTREGA']['end'];
        $row['DTINICOT'] = $row['DT_VALIDADE']['start'];
        $row['DTFINCOT'] = $row['DT_VALIDADE']['end'];
        
        $tipoRelatorio = $row['STRATEGY'];
        
        if($tipoRelatorio == "BIRT") {
            // Unidade Solicitante
            $nrlistaFilSoli = $this->criarListaValores($row['CDFILSOLI']);
            $row['CDFILSOLI'] = "_NRLISTA=".$nrlistaFilSoli;
    
            // Unidade de Lançamento
            $nrlistaFillanca = $this->criarListaValores($row['CDFILLANCA']);
            $row['CDFILLANCA'] = "_NRLISTA=".$nrlistaFillanca;
            
            // Região
            if($row['CDREGIAO'] != 'T'){
                $nrlistaRegiao = $this->criarListaValores($row['CDREGIAO']);
                $row['CDREGIAO'] = "_NRLISTA=".$nrlistaRegiao;
            }
            
            // Comprador
            if($row['CDOPERADOR'] != 'T'){
                $nrlistaOperador = $this->criarListaValores($row['CDOPERADOR']);
                $row['CDOPERADOR'] = "_NRLISTA=".$nrlistaRegiao;
            }
            
            // Solicitação
            if($row['NRSOLICMP'] != 'T'){
                $nrlistaSolic = $this->criarListaValores($row['NRSOLICMP']);
                $row['NRSOLICMP'] = "_NRLISTA=".$nrlistaSolic;
            }
            
            $paramRelatorio =  array (
                    "CDFILIAL"    => "P_CDFILIAL",
                    "CDFILSOLI"   => "P_CDFILIALSOLI",
                    "CDFILLANCA"  => "P_CDFILIALLANC",
                    "CDREGIAO"    => "P_CDREGIAO",
                    "CDOPERADOR"  => "P_CDOPERADOR",
                    "NRSOLICMP"   => "P_NRSOLICMP",
                    "DTINICIAL"   => "P_DTINICIAL",
                    "DTFINAL"     => "P_DTFINAL",
                    "P_NRORG"     => "P_NRORG"
            );
        }else {
            $row['CDFILLANCA1'] = $row['CDFILLANCA'];
            $row['CDFILLANCA2'] = $row['CDFILLANCA'];
            $row['CDFILLANCA3'] = $row['CDFILLANCA'];
            $row['NRSOLICMP1'] = $row['NRSOLICMP'];
            $row['CDOPERADOR1'] = $row['CDOPERADOR'];
            $row['CDOPERADOR2'] = $row['CDOPERADOR'];
            $row['CDREGIAO1'] = $row['CDREGIAO'];
            $row['CDREGIAO2'] = $row['CDREGIAO'];
            $row['CDREGIAO3'] = $row['CDREGIAO'];
            $row['CDFILSOLI1'] = $row['CDFILSOLI'];
            $row['CDFILSOLI2'] = $row['CDFILSOLI'];
            $row['CDFILSOLI3'] = $row['CDFILSOLI'];
            if($row["__report_name"] == "SUP04000") {
                $paramRelatorio =  array (
                    "DTINICIAL"      => "P_DTINICIAL",
                    "DTFINAL"        => "P_DTFINAL",
                    "CDFILSOLI"      => "L_CDFILIALSOLI",
                    "CDFILLANCA"     => "L_CDFILIALLANC",
                    "NRSOLICMP"      => "L_SOLICITA",
                    "CDREGIAO"       => "L_CDREGIAO",
                    "CDFILIAL"       => "P_CDFILIAL",
                    "CDFILSOLI1"     => "L_CDFILIALSOLI1",
                    "CDFILLANCA1"    => "L_CDFILIALLANC1",
                    "CDOPERADOR"     => "L_CDCOMPRADOR",
                    "CDREGIAO1"      => "L_CDREGIAO1",
                    "CDFILSOLI2"     => "L_CDFILIALSOLI2",
                    "CDFILLANCA2"    => "L_CDFILIALLANC2",
                    "NRSOLICMP1"     => "L_SOLICITA1",
                    "CDREGIAO2"      => "L_CDREGIAO2",
                    "CDFILSOLI3"     => "L_CDFILIALSOLI3",
                    "CDFILLANCA3"    => "L_CDFILIALLANC3",
                    "CDOPERADOR1"    => "L_CDCOMPRADOR1",
                    "CDREGIAO3"      => "L_CDREGIAO3"
                );
            } else if($row["__report_name"] == "SUP04001"){
                $paramRelatorio =  array (
                    "DTINICIAL"      => "P_DTINICIAL",
                    "DTFINAL"        => "P_DTFINAL",
                    "CDFILSOLI"      => "L_CDFILIALSOLI",
                    "CDFILLANCA"     => "L_CDFILIALLANC",
                    "CDREGIAO"       => "L_CDREGIAO",
                    "NRSOLICMP"      => "L_SOLICITA",
                    "CDOPERADOR"     => "L_CDCOMPRADOR",
                    "CDFILIAL"       => "P_CDFILIAL",
                    "CDFILSOLI1"     => "L_CDFILIALSOLI1",
                    "CDFILLANCA1"    => "L_CDFILIALLANC1",
                    "CDREGIAO1"      => "L_CDREGIAO1",
                    "NRSOLICMP1"     => "L_SOLICITA1",
                    "CDOPERADOR1"    => "L_CDCOMPRADOR1",
                    "CDOPERADOR2"    => "L_CDCOMPRADOR2"
                );
            } else if($row["__report_name"] == "SUP04011") {
                 $paramRelatorio = array (
                    "CDFILIAL"    => "P_CDFILIAL",
                    "CDFILSOLI"   => "P_CDFILIALSOLI",
                    "CDREGIAO"    => "P_CDREGIAO",
                    "CDOPERADOR"  => "P_CDCOMPRADOR",
                    "CDPRODINI"   => "P_CDPRODINI",
                    "CDPRODFIN"   => "P_CDPRODFIN",
                    "DTINICIAL"   => "P_DTINICIAL",
                    "DTFINAL"     => "P_DTFINAL",
                    "DTINICOT"    => "P_DTINICOT",
                    "DTFINCOT"    => "P_DTFINCOT",
                    "CDFILLANCA"  => "L_CDFILIALLANC",
                    "CDFILLANCA1" => "L_CDFILIALLANC1",
                    "CDFILLANCA2" => "L_CDFILIALLANC2",
                    "CDFILLANCA3" => "L_CDFILIALLANC3",
                    "NRSOLICMP"   => "L_SOLICITA",
                    "NRSOLICMP1"  => "L_SOLICITA1"
                 );
            }
        }
        $this->reportMapping[$this->stNomeRel] =
        array(
            'strategy' => $tipoRelatorio,
            'parameterMapping' => $paramRelatorio
        );
    }
    
     public function verificaIdsisdos(DTO\Request $request, DTO\Response $response) {
        
         $params = array(
    		"NRORG" => $this->environment->getNrorg()
    	);
    	
    	$sql = "SELECT IDSISDOS FROM PARAMGERAL WHERE NRORG = :NRORG";
    	$query = $this->connection->prepare($sql);
    	$query->execute($params);
    	$resp = $query->fetchAll();

    $response->addDataSet(new DataSet("resp", $resp));
      
    }
    public function getCdFilial() {
        $query = "SELECT DISTINCT
                    NVL(FILIAL.CDFILCENTCMP, FILIAL.CDFILIAL)  AS CDFILIAL
                  FROM
                    FILIAL FIL,
                    FILIAL
                  WHERE
                    (FILIAL.CDFILIAL = :P_CDFILIAL) AND
                    NVL(FILIAL.CDFILCENTCMP, FILIAL.CDFILIAL) = FIL.CDFILIAL";
        $stmt = $this->connection->prepare($query);
        $stmt->execute(array(
            "P_CDFILIAL" => $this->environment->getCdFilial()
		));
        $cdfilial = $stmt->fetchAll()[0]["CDFILIAL"];
        return $cdfilial;
    }
    
   //cria lista de valores recebendo string como parametro
    protected function criarListaValores($lista){
        $nrlista = $this->newCode->getCodeByTableName('LISTA', $this->environment->getNrOrg());
        $valores = explode('_',$lista);
        try{
            foreach($valores as $key){
                $this->insertLista($nrlista, $key);
            }
            return $nrlista;
        } catch(\Exception $e){
            throw $e;
        }
     }
    
    //insere lista no banco
    public function insertLista($nrlista, $cdlista) {
        $params = array(
            "NRLISTA" => $nrlista,
            "CDLISTA" => $cdlista
        );
        
        $sql = "INSERT INTO LISTA (NRLISTA, CDLISTA) VALUES (:NRLISTA, :CDLISTA)";
        $query = $this->connection->prepare($sql);
        $query->execute($params);
    }
    
}