/******************************************************************************/
/******************************************************************************/
/*                                                                            */
/* Trigger: DTULTATU_APRERECE                                                 */
/* Tabela : APRERECE                                                          */
/*                                                                            */
/* Criao:                                                                   */
/* 14/03/2002 - Alexis Tolentino de Moura                                     */
/*                                                                            */
/******************************************************************************/

CREATE OR REPLACE TRIGGER DTULTATU_APRERECE
BEFORE INSERT OR UPDATE OR DELETE
ON APRERECE FOR EACH ROW

BEGIN
   IF INSERTING THEN
      :NEW.DTULTATUAPRE := SYSDATE;
   END IF;
   IF UPDATING THEN
      IF (NVL(:OLD.NMAPRERECE,0) <> NVL(:NEW.NMAPRERECE,0)) OR
         (NVL(:OLD.CDAPRERECE,0) <> NVL(:NEW.CDAPRERECE,0)) THEN
         :NEW.DTULTATUAPRE := SYSDATE;
      END IF;
   END IF;
   IF DELETING THEN
      INSERT INTO DELETECACHE (NMTABLECACHE, CDFILICACHE, DSKEYCACHE, DTULTATUCACH)
                       VALUES ('APRERECE', '', 'CDAPRERECE='||:OLD.CDAPRERECE||';', SYSDATE);
   END IF;
END;
/

ALTER TABLE APRERECE MODIFY DTULTATUAPRE DEFAULT SYSDATE
/
